/*
C
C  _______________________________________________________________
C
C*   Licence
C    =======
C
C    You may use or modify this code for your own non commercial
C    purposes for an unlimited time. 
C    In any case you should not deliver this code without a special 
C    permission of ZIB.
C    In case you intend to use the code commercially, we oblige you
C    to sign an according licence agreement with ZIB.
C
C
C  _______________________________________________________________
C
*/

#include <math.h>
#include "kask.h"
#include "kasktri.h"
#include "kaskass.h"
#include "kaskcmd.h"

 
REAL *iPointX, *iPointY, *iPointZ, *iWeight,
     **shape, **shapeX, **shapeY, **shapeZ,
     **shapeXX, **shapeXY, **shapeYY;


REAL AreaT(p1,p2,p3)
   PT *p1, *p2, *p3;
{
   REAL area, areaT1, areaT2, areaT3;
   REAL dx1, dy1, dz1, dx2, dy2, dz2;

   dx1 = p2->x - p1->x;
   dy1 = p2->y - p1->y;
   dz1 = p2->z - p1->z;
   dx2 = p3->x - p1->x;
   dy2 = p3->y - p1->y;
   dz2 = p3->z - p1->z;
                         
   areaT1 = dy1*dz2 - dz1*dy2;
   areaT2 = dz1*dx2 - dx1*dz2;
   areaT3 = dx1*dy2 - dy1*dx2;
   area  = areaT1*areaT1
          + areaT2*areaT2 + areaT3*areaT3;
   area = sqrt(area);

   return area;
}

 
INT ConstAss(t)
  TR3 *t;
  {
    PT   *p1 = t->p1,*p2 = t->p2,*p3 = t->p3,*p4 = t->p4;
    TR2  **ts;
    REAL fVals[NO_OF_F_VALS], cauVals[NO_OF_CAU_VALS];
    REAL f11, f12, f13, f21, f22, f23, f31, f32, f33;
    REAL e11, e12, e13, e21, e22, e23, e31, e32, e33;
    REAL e1111, e1121, e1131, e2121, e2131, e3131;
    REAL e1212, e1222, e1232, e2222, e2232, e3232;
    REAL e1313, e1323, e1333, e2323, e2333, e3333;
    REAL hilfe, fac1, fac2;
    REAL sXX,sXY,sXZ,sYX,sYY,sYZ,sZX,sZY,sZZ;
    REAL xm, ym, zm, pX[16], pY[16], pZ[16], qxy[16], gxy[16];
    REAL d, dAbs, fac00, fac30, fac24, fac445,s;
    REAL valDiag, valSub;
    INT  i,k,kk,m;

    f11 = (p2->x)-(p1->x);
    f12 = (p3->x)-(p1->x);
    f13 = (p4->x)-(p1->x);
    f21 = (p2->y)-(p1->y);
    f22 = (p3->y)-(p1->y);
    f23 = (p4->y)-(p1->y);
    f31 = (p2->z)-(p1->z);
    f32 = (p3->z)-(p1->z);
    f33 = (p4->z)-(p1->z);


    dAbs = t->volume*6.0;



    if ( (partP==P_STIFF)||(partP==P_ALL) )
      {
          xm = f11*iPointX[0]+f12*iPointY[0]+f13*iPointZ[0]+(p1->x);
          ym = f21*iPointX[0]+f22*iPointY[0]+f23*iPointZ[0]+(p1->y);
          zm = f31*iPointX[0]+f32*iPointY[0]+f33*iPointZ[0]+(p1->z);

          (actProblem->F)(xm, ym, zm, t->class,fVals,P_STIFF);

          pX[0]  = fVals[0];
          pY[0]  = fVals[1];
          pZ[0]  = fVals[2];
          qxy[0] = fVals[3];

          e11 = f22*f33 - f23*f32;
          e12 = f13*f32 - f12*f33;
          e13 = f12*f23 - f13*f22;
          e21 = f23*f31 - f21*f33;
          e22 = f11*f33 - f13*f31;
          e23 = f13*f21 - f11*f23;
          e31 = f21*f32 - f22*f31;
          e32 = f12*f31 - f11*f32;
          e33 = f11*f22 - f12*f21;

          e1111 = e11*e11;
          e1121 = e11*e21;
          e1131 = e11*e31;
          e2121 = e21*e21;
          e2131 = e21*e31;
          e3131 = e31*e31;

          e1212 = e12*e12;
          e1222 = e12*e22;
          e1232 = e12*e32;
          e2222 = e22*e22;
          e2232 = e22*e32;
          e3232 = e32*e32;

          e1313 = e13*e13;
          e1323 = e13*e23;
          e1333 = e13*e33;
          e2323 = e23*e23;
          e2333 = e23*e33;
          e3333 = e33*e33;

       switch (curAss)
         {
          case N_STD:
            fac00 = ONE/60.0;
            fac30 = ONE/120.0;

            assA[0][0] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111+e1121+e1131   +
                     e1121+e2121+e2131   +
                     e1131+e2131+e3131)  +
                  pY[0]* 
                    (e1212+e1222+e1232   +
                     e1222+e2222+e2232   +
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1313+e1323+e1333   +
                     e1323+e2323+e2333   +
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*fac00
                );

            assA[1][0] = (-(1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111+e1121+e1131)   +
                  pY[0]* 
                    (e1212+e1222+e1232)   +
                  pZ[0]*  
                    (e1313+e1323+e1333))  +

                  dAbs*qxy[0]*fac30
                );


            assA[1][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* e1111  +
                  pY[0]* e1212  +
                  pZ[0]* e1313) +

                  dAbs*qxy[0]*fac00
                );

            assA[2][0] = (-(1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1121+e2121+e2131)   +
                  pY[0]* 
                    (e1222+e2222+e2232)   +
                  pZ[0]*  
                    (e1323+e2323+e2333))  +

                  dAbs*qxy[0]*fac30
                );

            assA[2][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*e1121 + pY[0]*e1222 + pZ[0]*e1323) +

                  dAbs*qxy[0]*fac30
                );

            assA[2][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* e2121  +
                  pY[0]* e2222  +
                  pZ[0]* e2323) +

                  dAbs*qxy[0]*fac00
                );

            assA[3][0] = (-(1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1131+e2131+e3131)  +
                  pY[0]* 
                    (e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1333+e2333+e3333)) +

                  dAbs*qxy[0]*fac30
                );

            assA[3][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* e1131  +
                  pY[0]* e1232  +
                  pZ[0]* e1333) +

                  dAbs*qxy[0]*fac30
                );

            assA[3][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* (e2131)  +
                  pY[0]* (e2232)  +
                  pZ[0]* (e2333)) +

                  dAbs*qxy[0]*fac30
                );

            assA[3][3] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* e3131  +
                  pY[0]* e3232  +
                  pZ[0]* e3333) +

                  dAbs*qxy[0]*fac00
                );

            break;
   
          case N_LQ:

            assA[4][0] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111+e1121+e1131  +
                     e1131+e2131+e3131) +
                  pY[0]* 
                    (e1212+e1222+e1232   +
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1313+e1323+e1333   +
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*1.111111e-02
                );


            assA[4][1] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*  (e1111 + e31*e11 ) +
                  pY[0]*  (e1212 + e1232 )  +
                  pZ[0]*  (e1313 + e1333 )) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[4][2] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]* ( e1121 + e2131 ) +
                  pY[0]* ( e1222 + e2232 )  +
                  pZ[0]* ( e1323 + e2333 )) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[4][3] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]* ( e1131 + e3131)  +
                  pY[0]* ( e1232 + e3232)  +
                  pZ[0]* ( e1333 + e3333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[5][0] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1111+e1121+e1131   +
                     e1121+e2121+e2131 ) +
                  pY[0]* 
                    (e1212+e1222+e1232   +
                     e1222+e2222+e2232 ) +
                  pZ[0]*  
                    (e1313+e1323+e1333   +
                     e1323+e2323+e2333 )) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[5][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* (e1111 + e1121 ) +
                  pY[0]* (e1212 + e1222 ) +
                  pZ[0]* (e1313 + e1323 )) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[5][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* (e1121 + e2121 )  +
                  pY[0]* (e1222 + e2222 )  +
                  pZ[0]* (e1323 + e2323 )) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[5][3] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* (e1131 + e2131 ) +
                  pY[0]* (e1232 + e2232 ) +
                  pZ[0]* (e1333 + e2333 )) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[6][0] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1121+e2121+e2131   +
                     e1131+e2131+e3131) +
                  pY[0]* 
                    (e1222+e2222+e2232   +
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1323+e2323+e2333   +
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[6][1] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]* (e1121 + e1131) +
                  pY[0]* (e1222 + e1232)  +
                  pZ[0]* (e1323 + e1333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[6][2] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e2121   + e2131) +
                  pY[0]* 
                    (e2222   + e2232)  +
                  pZ[0]*  
                    (e2323   + e2333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[6][3] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e2131   + e3131) +
                  pY[0]* 
                    (e2232   + e3232)  +
                  pZ[0]*  
                    (e2333   + e3333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[7][0] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1121+e2121+e2131   +
                     e1131+e2131+e3131) +
                  pY[0]* 
                    (e1222+e2222+e2232   +
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1323+e2323+e2333   +
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[7][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1121   + e1131) +
                  pY[0]* 
                    (e1222   + e1232)  +
                  pZ[0]*  
                    (e1323   + e1333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[7][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e2121 + e2131) +
                  pY[0]* 
                    (e2222 + e2232)  +
                  pZ[0]*  
                    (e2323 + e2333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[7][3] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e2131 + e3131) +
                  pY[0]* 
                    (e2232 + e3232)  +
                  pZ[0]*  
                    (e2333 + e3333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[8][0] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1111+e1121+e1131   +
                     e1131+e2131+e3131) +
                  pY[0]* 
                    (e1212+e1222+e1232   +                
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1313+e1323+e1333   +          
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[8][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111   + e1131) +
                  pY[0]* 
                    (e1212   + e1232)  +
                  pZ[0]*  
                    (e1313   + e1333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[8][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1121   + e2131) +
                  pY[0]* 
                    (e1222   + e2232)  +
                  pZ[0]*  
                    (e1323   + e2333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[8][3] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1131 + e3131) +
                  pY[0]* 
                    (e1232 + e3232)  +
                  pZ[0]*  
                    (e1333 + e3333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[9][0] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111+e1121+e1131   +
                     e1121+e2121+e2131   
                     ) +
                  pY[0]* 
                    (e1212+e1222+e1232   +
                     e1222+e2222+e2232   
                     )  +
                  pZ[0]*  
                    (e1313+e1323+e1333   +
                     e1323+e2323+e2333   
                     )) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[9][1] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1111  + e1121) +
                  pY[0]* 
                    (e1212  + e1222)  +
                  pZ[0]*  
                    (e1313  + e1323)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[9][2] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1121 + e2121 ) +
                  pY[0]* 
                    (e1222 + e2222 )  +
                  pZ[0]*  
                    (e1323 + e2323 )) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[9][3] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1131  + e2131  ) +
                  pY[0]* 
                    (e1232  + e2232  )  +
                  pZ[0]*  
                    (e1333  + e2333  )) +

                  dAbs*qxy[0]*1.111111e-02
                );

              break;

          case N_QQ:

            fac1 = 1.33333333333333e-01;
            fac2 = 2.66666666666667e-01;
            assA[4][4] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e1131+e2121+e1131+e3131)*fac2   +
                     (e1121+e1121+e2131+e2131)*fac1 )         +
                  pY[0]* 
                    ((e1212+e1232+e2222+e1232+e3232)*fac2   +
                     (e1222+e1222+e2232+e2232)*fac1 )         +
                  pZ[0]*  
                    ((e1313+e1333+e2323+e1333+e3333)*fac2   +
                     (e1323+e1323+e2333+e2333)*fac1  ))       +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[5][5] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e2121)*fac2+(e1121+e1121)*fac1 )  +
                  pY[0]* 
                    ((e1212+e2222)*fac2+(e1222+e1222)*fac1 )  +
                  pZ[0]*  
                    ((e1313+e2323)*fac2+(e1323+e1323)*fac1 )) +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[6][6] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e2121+e2131+e2131+e3131)*fac2 +
                     (e1121+e1131+e1121+e1131)*fac1  )      +
                  pY[0]* 
                    ((e1212+e2222+e2232+e2232+e3232)*fac2 +
                     (e1222+e1232+e1222+e1232)*fac1  )      +
                  pZ[0]*  
                    ((e1313+e2323+e2333+e2333+e3333)*fac2 +
                     (e1323+e1333+e1323+e1333)*fac1  ))     +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[7][7] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e2121+e3131)*fac2+(e2131+e2131)*fac1 ) +
                  pY[0]* 
                    ((e2222+e3232)*fac2+(e2232+e2232)*fac1)  +
                  pZ[0]*  
                    ((e2323+e3333)*fac2+(e2333+e2333)*fac1)) +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[8][8] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e3131)*fac2+(e1131+e1131)*fac1)  +
                  pY[0]* 
                    ((e1212+e3232)*fac2+(e1232+e1232)*fac1)  +
                  pZ[0]*  
                    ((e1313+e3333)*fac2+(e1333+e1333)*fac1)) +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[9][9] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e1121+e1121+e2121+e3131)*fac2  +
                     (e1131+e2131+e1131+e2131)*fac1)         +
                  pY[0]* 
                    ((e1212+e1222+e1222+e2222+e3232)*fac2  +
                     (e1232+e2232+e1232+e2232)*fac1)         +
                  pZ[0]*  
                    ((e1313+e1323+e1323+e2323+e3333)*fac2  +
                     (e1333+e2333+e1333+e2333)*fac1))        +

                  dAbs*qxy[0]*1.018519e-02
                );

                     break;
          default:
                     break;
         }
      }

    if ( (partP==P_RHS)||(partP==P_ALL) )
      {
        if ((t->gValsP) == false)
          {
            for (m = 0; m<noOfIPoints; m++)
              {
               xm = f11*iPointX[m]+f12*iPointY[m]+f13*iPointZ[m]+(p1->x);
               ym = f21*iPointX[m]+f22*iPointY[m]+f23*iPointZ[m]+(p1->y);
               zm = f31*iPointX[m]+f32*iPointY[m]+f33*iPointZ[m]+(p1->z);

               (actProblem->F)(xm, ym, zm, t->class,fVals,P_RHS);

      /*         gxy[m] = fVals[4];    */
               (t->gVals)[m] = iWeight[m]*fVals[4]; 
                t->gValsP = true;
              }
          }

        for (i = iFrom; i<iTo; i++)
           {
             assB[i] = ZERO;
             for (m = 0; m<noOfIPoints; m++)
                {
                  hilfe = (t->gVals)[m]*shape[i][m];
                  assB[i] += hilfe;
                }
              assB[i] = assB[i]*dAbs;
           }
      }  

        /*
                 Cauchy Randbedingungen   
        */
       fac24 = ONE/24.0;
       fac30 = ONE/30.0;
       fac445 = FOUR/45.0;
       ts = &(t->t1);
       for (k=0; k<4;k++)
          {
            if ( (ts[k]->boundP) == CAUCHY )
              {
                (actProblem->CauchyF)(ZERO,ZERO,ZERO,ts[k]->class,cauVals,0);
                switch (k)
                  {
                    case 0 :
                      s = AreaT(p2,p3,p4);
                      if ( (partP==P_STIFF)||(partP==P_ALL) )
                        {
                           switch (curAss)
                            {
                              case N_STD:
                                valSub  = s*fac24*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[1][1] += valDiag;
                                assA[2][1] += valSub;
                                assA[2][2] += valDiag;
                                assA[3][1] += valSub;
                                assA[3][2] += valSub;
                                assA[3][3] += valDiag;
                                break;
                              case N_LQ:
                                valSub  = s*fac30*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[5][1] += valDiag;
                                assA[5][2] += valDiag;
                                assA[5][3] += valSub;
                                assA[7][1] += valSub;
                                assA[7][2] += valDiag;
                                assA[7][3] += valDiag;
                                assA[8][1] += valDiag;
                                assA[8][2] += valSub;
                                assA[8][3] += valDiag;
                                break;
                              case N_QQ:
                                valDiag = s*fac445*cauVals[0];
                                assA[5][5] += valDiag;
                                assA[7][7] += valDiag;
                                assA[8][8] += valDiag;
                                break;
                            }
                        }
                      if ( (partP == P_RHS) || (partP == P_ALL) )
                        {
                           valSub = s*SIXTH*cauVals[1];
                           switch (curAss)
                            {
                              case N_STD:
                                assB[1] +=  valSub;
                                assB[2] +=  valSub;
                                assB[3] +=  valSub;
                                break;
                              case N_LQ:
                              case N_QQ:
                                assB[5] +=  valSub;
                                assB[7] +=  valSub;
                                assB[8] +=  valSub;
                                break;
                            }
                        }
                      break;
                    case 1 :
                      s = AreaT(p1,p3,p4);
                      if ( (partP==P_STIFF)||(partP==P_ALL) )
                        {
                          switch (curAss)
                            {
                              case N_STD:
                                valSub  = s*fac24*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[0][0] += valDiag;
                                assA[2][0] += valSub;
                                assA[2][2] += valDiag;
                                assA[3][0] += valSub;
                                assA[3][2] += valSub;
                                assA[3][3] += valDiag;
                                break;
                              case N_LQ:
                                valSub  = s*fac30*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[4][0] += valDiag;
                                assA[4][2] += valDiag;
                                assA[4][3] += valSub;
                                assA[7][0] += valSub;
                                assA[7][2] += valDiag;
                                assA[7][3] += valDiag;
                                assA[9][0] += valDiag;
                                assA[9][2] += valSub;
                                assA[9][3] += valDiag;
                                break;
                              case N_QQ:
                                valDiag = s*fac445*cauVals[0];
                                assA[4][4] += valDiag;
                                assA[7][7] += valDiag;
                                assA[9][9] += valDiag;
                                break;
                            }
                        }
                      if ( (partP == P_RHS) || (partP == P_ALL) )
                        {
                           valSub = s*SIXTH*cauVals[1];
                           switch (curAss)
                            {
                              case N_STD:
                                assB[0] +=  valSub;
                                assB[2] +=  valSub;
                                assB[3] +=  valSub;
                                break;
                              case N_LQ:
                              case N_QQ:
                                assB[4] +=  valSub;
                                assB[7] +=  valSub;
                                assB[9] +=  valSub;
                                break;
                            }
                        }
                      break;
                    case 2 :
                      s = AreaT(p1,p2,p4);
                      if ( (partP==P_STIFF)||(partP==P_ALL) )
                         {
                           switch (curAss)
                            {
                              case N_STD:
                                valSub  = s*fac24*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[0][0] += valDiag;
                                assA[1][0] += valSub;
                                assA[1][1] += valDiag;
                                assA[3][0] += valSub;
                                assA[3][1] += valSub;
                                assA[3][3] += valDiag;
                                break;
                              case N_LQ:
                                valSub  = s*fac30*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[6][0] += valDiag;
                                assA[6][1] += valDiag;
                                assA[6][3] += valSub;
                                assA[8][0] += valSub;
                                assA[8][1] += valDiag;
                                assA[8][3] += valDiag;
                                assA[9][0] += valDiag;
                                assA[9][1] += valSub;
                                assA[9][3] += valDiag;
                                break;
                              case N_QQ:
                                valDiag = s*fac445*cauVals[0];
                                assA[6][6] += valDiag;
                                assA[8][8] += valDiag;
                                assA[9][9] += valDiag;
                                break;
                            }
                         }
                      if ( (partP == P_RHS) || (partP == P_ALL) )
                        {
                           valSub = s*SIXTH*cauVals[1];
                           switch (curAss)
                            {
                              case N_STD:
                                assB[0] +=  valSub;
                                assB[1] +=  valSub;
                                assB[3] +=  valSub;
                                break;
                              case N_LQ:
                              case N_QQ:
                                assB[6] +=  valSub;
                                assB[8] +=  valSub;
                                assB[9] +=  valSub;
                                break;
                            }
                        }
                      break;
                    case 3 :
                      s = AreaT(p1,p2,p3);
                      if ( (partP==P_STIFF)||(partP==P_ALL) )
                         {
                           switch (curAss)
                            {
                              case N_STD:
                                valSub  = s*fac24*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[0][0] += valDiag;
                                assA[1][0] += valSub;
                                assA[1][1] += valDiag;
                                assA[2][0] += valSub;
                                assA[2][1] += valSub;
                                assA[2][2] += valDiag;
                                break;
                              case N_LQ:
                                valSub  = s*fac30*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[4][0] += valDiag;
                                assA[4][1] += valSub;
                                assA[4][2] += valDiag;
                                assA[5][0] += valSub;
                                assA[5][1] += valDiag;
                                assA[5][2] += valDiag;
                                assA[6][0] += valDiag;
                                assA[6][1] += valDiag;
                                assA[6][2] += valSub;
                                break;
                              case N_QQ:
                                valDiag = s*fac445*cauVals[0];
                                assA[4][4] += valDiag;
                                assA[5][5] += valDiag;
                                assA[6][6] += valDiag;
                                break;
                            }
                         }
                      if ( (partP == P_RHS) || (partP == P_ALL) )
                        {
                           valSub = s*SIXTH*cauVals[1];
                           switch (curAss)
                            {
                              case N_STD:
                                assB[0] +=  valSub;
                                assB[1] +=  valSub;
                                assB[2] +=  valSub;
                                break;
                              case N_LQ:
                              case N_QQ:
                                assB[4] +=  valSub;
                                assB[5] +=  valSub;
                                assB[6] +=  valSub;
                                break;
                            }
                        }
                      break;
                  }
              }
         }

    return true;
  }


INT HyperAss(t)
  TR3 *t;
  {
    PT   *p1 = t->p1,*p2 = t->p2,*p3 = t->p3,*p4 = t->p4;
    TR2  **ts;
    REAL fVals[NO_OF_F_VALS], cauVals[NO_OF_CAU_VALS];
    REAL f11, f12, f13, f21, f22, f23, f31, f32, f33;
    REAL e11, e12, e13, e21, e22, e23, e31, e32, e33;
    REAL e1111, e1121, e1131, e2121, e2131, e3131;
    REAL e1212, e1222, e1232, e2222, e2232, e3232;
    REAL e1313, e1323, e1333, e2323, e2333, e3333;
    REAL hilfe, fac1, fac2;
    REAL sXX,sXY,sXZ,sYX,sYY,sYZ,sZX,sZY,sZZ;
    REAL xm, ym, zm, pX[16], pY[16], pZ[16], qxy[16], gxy[16];
    REAL d, dAbs, fac00, fac24, fac30, fac445;
    INT  i,k,kk,m;
    float absE2;
    float xf, yf,zf;
    REAL sigma, valDiag, valSub, s;


    f11 = (p2->x)-(p1->x);
    f12 = (p3->x)-(p1->x);
    f13 = (p4->x)-(p1->x);
    f21 = (p2->y)-(p1->y);
    f22 = (p3->y)-(p1->y);
    f23 = (p4->y)-(p1->y);
    f31 = (p2->z)-(p1->z);
    f32 = (p3->z)-(p1->z);
    f33 = (p4->z)-(p1->z);


    dAbs = t->volume*6.0;



    if ( (partP==P_STIFF)||(partP==P_ALL) )
      {
          xm = f11*iPointX[0]+f12*iPointY[0]+f13*iPointZ[0]+(p1->x);
          ym = f21*iPointX[0]+f22*iPointY[0]+f23*iPointZ[0]+(p1->y);
          zm = f31*iPointX[0]+f32*iPointY[0]+f33*iPointZ[0]+(p1->z);

          (actProblem->F)(xm, ym, zm, t->class,fVals,P_STIFF);

          pX[0]  = fVals[0];
          pY[0]  = fVals[1];
          pZ[0]  = fVals[2];
          qxy[0] = fVals[3];

          e11 = f22*f33 - f23*f32;
          e12 = f13*f32 - f12*f33;
          e13 = f12*f23 - f13*f22;
          e21 = f23*f31 - f21*f33;
          e22 = f11*f33 - f13*f31;
          e23 = f13*f21 - f11*f23;
          e31 = f21*f32 - f22*f31;
          e32 = f12*f31 - f11*f32;
          e33 = f11*f22 - f12*f21;

          e1111 = e11*e11;
          e1121 = e11*e21;
          e1131 = e11*e31;
          e2121 = e21*e21;
          e2131 = e21*e31;
          e3131 = e31*e31;

          e1212 = e12*e12;
          e1222 = e12*e22;
          e1232 = e12*e32;
          e2222 = e22*e22;
          e2232 = e22*e32;
          e3232 = e32*e32;

          e1313 = e13*e13;
          e1323 = e13*e23;
          e1333 = e13*e33;
          e2323 = e23*e23;
          e2333 = e23*e33;
          e3333 = e33*e33;

       switch (curAss)
         {
          case N_STD:
            fac00 = ONE/60.0;
            fac30 = ONE/120.0;

            assA[0][0] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111+e1121+e1131   +
                     e1121+e2121+e2131   +
                     e1131+e2131+e3131)  +
                  pY[0]* 
                    (e1212+e1222+e1232   +
                     e1222+e2222+e2232   +
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1313+e1323+e1333   +
                     e1323+e2323+e2333   +
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*fac00
                );

            assA[1][0] = (-(1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111+e1121+e1131)   +
                  pY[0]* 
                    (e1212+e1222+e1232)   +
                  pZ[0]*  
                    (e1313+e1323+e1333))  +

                  dAbs*qxy[0]*fac30
                );


            assA[1][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* e1111  +
                  pY[0]* e1212  +
                  pZ[0]* e1313) +

                  dAbs*qxy[0]*fac00
                );

            assA[2][0] = (-(1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1121+e2121+e2131)   +
                  pY[0]* 
                    (e1222+e2222+e2232)   +
                  pZ[0]*  
                    (e1323+e2323+e2333))  +

                  dAbs*qxy[0]*fac30
                );

            assA[2][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*e1121 + pY[0]*e1222 + pZ[0]*e1323) +

                  dAbs*qxy[0]*fac30
                );

            assA[2][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* e2121  +
                  pY[0]* e2222  +
                  pZ[0]* e2323) +

                  dAbs*qxy[0]*fac00
                );

            assA[3][0] = (-(1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1131+e2131+e3131)  +
                  pY[0]* 
                    (e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1333+e2333+e3333)) +

                  dAbs*qxy[0]*fac30
                );

            assA[3][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* e1131  +
                  pY[0]* e1232  +
                  pZ[0]* e1333) +

                  dAbs*qxy[0]*fac30
                );

            assA[3][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* (e2131)  +
                  pY[0]* (e2232)  +
                  pZ[0]* (e2333)) +

                  dAbs*qxy[0]*fac30
                );

            assA[3][3] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* e3131  +
                  pY[0]* e3232  +
                  pZ[0]* e3333) +

                  dAbs*qxy[0]*fac00
                );


            break;
   
          case N_LQ:

            assA[4][0] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111+e1121+e1131  +
                     e1131+e2131+e3131) +
                  pY[0]* 
                    (e1212+e1222+e1232   +
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1313+e1323+e1333   +
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*1.111111e-02
                );


            assA[4][1] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*  (e1111 + e31*e11 ) +
                  pY[0]*  (e1212 + e1232 )  +
                  pZ[0]*  (e1313 + e1333 )) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[4][2] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]* ( e1121 + e2131 ) +
                  pY[0]* ( e1222 + e2232 )  +
                  pZ[0]* ( e1323 + e2333 )) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[4][3] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]* ( e1131 + e3131)  +
                  pY[0]* ( e1232 + e3232)  +
                  pZ[0]* ( e1333 + e3333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[5][0] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1111+e1121+e1131   +
                     e1121+e2121+e2131 ) +
                  pY[0]* 
                    (e1212+e1222+e1232   +
                     e1222+e2222+e2232 ) +
                  pZ[0]*  
                    (e1313+e1323+e1333   +
                     e1323+e2323+e2333 )) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[5][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* (e1111 + e1121 ) +
                  pY[0]* (e1212 + e1222 ) +
                  pZ[0]* (e1313 + e1323 )) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[5][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* (e1121 + e2121 )  +
                  pY[0]* (e1222 + e2222 )  +
                  pZ[0]* (e1323 + e2323 )) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[5][3] = ((1.0/dAbs)*SIXTH*
                 (pX[0]* (e1131 + e2131 ) +
                  pY[0]* (e1232 + e2232 ) +
                  pZ[0]* (e1333 + e2333 )) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[6][0] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1121+e2121+e2131   +
                     e1131+e2131+e3131) +
                  pY[0]* 
                    (e1222+e2222+e2232   +
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1323+e2323+e2333   +
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[6][1] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]* (e1121 + e1131) +
                  pY[0]* (e1222 + e1232)  +
                  pZ[0]* (e1323 + e1333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[6][2] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e2121   + e2131) +
                  pY[0]* 
                    (e2222   + e2232)  +
                  pZ[0]*  
                    (e2323   + e2333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[6][3] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e2131   + e3131) +
                  pY[0]* 
                    (e2232   + e3232)  +
                  pZ[0]*  
                    (e2333   + e3333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[7][0] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1121+e2121+e2131   +
                     e1131+e2131+e3131) +
                  pY[0]* 
                    (e1222+e2222+e2232   +
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1323+e2323+e2333   +
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[7][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1121   + e1131) +
                  pY[0]* 
                    (e1222   + e1232)  +
                  pZ[0]*  
                    (e1323   + e1333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[7][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e2121 + e2131) +
                  pY[0]* 
                    (e2222 + e2232)  +
                  pZ[0]*  
                    (e2323 + e2333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[7][3] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e2131 + e3131) +
                  pY[0]* 
                    (e2232 + e3232)  +
                  pZ[0]*  
                    (e2333 + e3333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[8][0] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1111+e1121+e1131   +
                     e1131+e2131+e3131) +
                  pY[0]* 
                    (e1212+e1222+e1232   +                
                     e1232+e2232+e3232)  +
                  pZ[0]*  
                    (e1313+e1323+e1333   +          
                     e1333+e2333+e3333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[8][1] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111   + e1131) +
                  pY[0]* 
                    (e1212   + e1232)  +
                  pZ[0]*  
                    (e1313   + e1333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[8][2] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1121   + e2131) +
                  pY[0]* 
                    (e1222   + e2232)  +
                  pZ[0]*  
                    (e1323   + e2333)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[8][3] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1131 + e3131) +
                  pY[0]* 
                    (e1232 + e3232)  +
                  pZ[0]*  
                    (e1333 + e3333)) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[9][0] = ((1.0/dAbs)*SIXTH*
                 (pX[0]*
                    (e1111+e1121+e1131   +
                     e1121+e2121+e2131   
                     ) +
                  pY[0]* 
                    (e1212+e1222+e1232   +
                     e1222+e2222+e2232   
                     )  +
                  pZ[0]*  
                    (e1313+e1323+e1333   +
                     e1323+e2323+e2333   
                     )) +

                  dAbs*qxy[0]*1.111111e-02
                );

            assA[9][1] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1111  + e1121) +
                  pY[0]* 
                    (e1212  + e1222)  +
                  pZ[0]*  
                    (e1313  + e1323)) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[9][2] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1121 + e2121 ) +
                  pY[0]* 
                    (e1222 + e2222 )  +
                  pZ[0]*  
                    (e1323 + e2323 )) +

                  dAbs*qxy[0]*5.555556e-03
                );

            assA[9][3] = ((1.0/dAbs)*(-SIXTH)*
                 (pX[0]*
                    (e1131  + e2131  ) +
                  pY[0]* 
                    (e1232  + e2232  )  +
                  pZ[0]*  
                    (e1333  + e2333  )) +

                  dAbs*qxy[0]*1.111111e-02
                );

              break;

          case N_QQ:

            fac1 = 1.33333333333333e-01;
            fac2 = 2.66666666666667e-01;
            assA[4][4] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e1131+e2121+e1131+e3131)*fac2   +
                     (e1121+e1121+e2131+e2131)*fac1 )         +
                  pY[0]* 
                    ((e1212+e1232+e2222+e1232+e3232)*fac2   +
                     (e1222+e1222+e2232+e2232)*fac1 )         +
                  pZ[0]*  
                    ((e1313+e1333+e2323+e1333+e3333)*fac2   +
                     (e1323+e1323+e2333+e2333)*fac1  ))       +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[5][5] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e2121)*fac2+(e1121+e1121)*fac1 )  +
                  pY[0]* 
                    ((e1212+e2222)*fac2+(e1222+e1222)*fac1 )  +
                  pZ[0]*  
                    ((e1313+e2323)*fac2+(e1323+e1323)*fac1 )) +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[6][6] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e2121+e2131+e2131+e3131)*fac2 +
                     (e1121+e1131+e1121+e1131)*fac1  )      +
                  pY[0]* 
                    ((e1212+e2222+e2232+e2232+e3232)*fac2 +
                     (e1222+e1232+e1222+e1232)*fac1  )      +
                  pZ[0]*  
                    ((e1313+e2323+e2333+e2333+e3333)*fac2 +
                     (e1323+e1333+e1323+e1333)*fac1  ))     +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[7][7] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e2121+e3131)*fac2+(e2131+e2131)*fac1 ) +
                  pY[0]* 
                    ((e2222+e3232)*fac2+(e2232+e2232)*fac1)  +
                  pZ[0]*  
                    ((e2323+e3333)*fac2+(e2333+e2333)*fac1)) +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[8][8] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e3131)*fac2+(e1131+e1131)*fac1)  +
                  pY[0]* 
                    ((e1212+e3232)*fac2+(e1232+e1232)*fac1)  +
                  pZ[0]*  
                    ((e1313+e3333)*fac2+(e1333+e1333)*fac1)) +

                  dAbs*qxy[0]*1.018519e-02
                );

            assA[9][9] = ((1.0/dAbs)*
                 (pX[0]*
                    ((e1111+e1121+e1121+e2121+e3131)*fac2  +
                     (e1131+e2131+e1131+e2131)*fac1)         +
                  pY[0]* 
                    ((e1212+e1222+e1222+e2222+e3232)*fac2  +
                     (e1232+e2232+e1232+e2232)*fac1)         +
                  pZ[0]*  
                    ((e1313+e1323+e1323+e2323+e3333)*fac2  +
                     (e1333+e2333+e1333+e2333)*fac1))        +

                  dAbs*qxy[0]*1.018519e-02
                );

                     break;
          default:
                     break;
         }
      }

    if ( (partP==P_RHS)||(partP==P_ALL) )
      {
        if ((t->gValsP) == false)
          {
             xm = f11*iPointX[0]+f12*iPointY[0]+f13*iPointZ[0]+(p1->x);
             ym = f21*iPointX[0]+f22*iPointY[0]+f23*iPointZ[0]+(p1->y);
             zm = f31*iPointX[0]+f32*iPointY[0]+f33*iPointZ[0]+(p1->z);
             (actProblem->F)(xm, ym, zm, t->class,fVals,P_RHS);
             sigma = fVals[4];
             xf = xm; yf = ym; zf = zm;
    /*         field3_(&xf,&yf,&zf,&absE2);   */
             (t->gVals)[0] = iWeight[0]*sigma*absE2; 
             t->gValsP = true;

             if (p1->gP == false)
               {
                 xf = (p1->x);
                 yf = (p1->y);
                 zf = (p1->z);
               /*  field3_(&xf,&yf,&zf,&absE2);  */
                 p1->g  = iWeight[1]*absE2; 
                 p1->gP = true;
               }
             (t->gVals)[1] = (p1->g)*sigma; 

             if (p2->gP == false)
               {
                 xf = (p2->x);
                 yf = (p2->y);
                 zf = (p2->z);
         /*        field3_(&xf,&yf,&zf,&absE2);  */
                 p2->g  = iWeight[2]*absE2; 
                 p2->gP = true;
               }
             (t->gVals)[2] = (p2->g)*sigma; 
            

             if (p3->gP == false)
               {
                 xf = (p3->x);
                 yf = (p3->y);
                 zf = (p3->z);
            /*     field3_(&xf,&yf,&zf,&absE2);  */
                 p3->g  = iWeight[3]*absE2; 
                 p3->gP = true;
               }
             (t->gVals)[3] = (p3->g)*sigma; 

             if (p4->gP == false)
               {
                 xf = (p4->x);
                 yf = (p4->y);
                 zf = (p4->z);
         /*       field3_(&xf,&yf,&zf,&absE2);  */
                 p4->g  = iWeight[4]*absE2; 
                 p4->gP = true;
               }
             (t->gVals)[4] = (p4->g)*sigma; 

          }

        for (i = iFrom; i<iTo; i++)
           {
             assB[i] = ZERO;
             for (m = 0; m<noOfIPoints; m++)
                {
                  hilfe = (t->gVals)[m]*shape[i][m];
                  assB[i] += hilfe;
                }
              assB[i] = assB[i]*dAbs;   
           }

      } 
 
        /*
                 Cauchy Randbedingungen   
        */
       fac24 = ONE/24.0;
       fac30 = ONE/30.0;
       fac445 = FOUR/45.0;
       ts = &(t->t1);
       for (k=0; k<4;k++)
          {
            if ( (ts[k]->boundP) == CAUCHY )
              {
                (actProblem->CauchyF)(ZERO,ZERO,ZERO,ts[k]->class,cauVals,0);
                switch (k)
                  {
                    case 0 :
                      s = AreaT(p2,p3,p4);
                      if ( (partP==P_STIFF)||(partP==P_ALL) )
                        {
                           switch (curAss)
                            {
                              case N_STD:
                                valSub  = s*fac24*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[1][1] += valDiag;
                                assA[2][1] += valSub;
                                assA[2][2] += valDiag;
                                assA[3][1] += valSub;
                                assA[3][2] += valSub;
                                assA[3][3] += valDiag;
                                break;
                              case N_LQ:
                                valSub  = s*fac30*cauVals[0];
                                valDiag = TWO*valSub;
/*   printf(" N_LQ %e %e \n",valSub,valDiag);   */
                                assA[5][1] += valDiag;
                                assA[5][2] += valDiag;
                                assA[5][3] += valSub;
                                assA[7][1] += valSub;
                                assA[7][2] += valDiag;
                                assA[7][3] += valDiag;
                                assA[8][1] += valDiag;
                                assA[8][2] += valSub;
                                assA[8][3] += valDiag;
                                break;
                              case N_QQ:
                                valDiag = s*fac445*cauVals[0];
                                assA[5][5] += valDiag;
                                assA[7][7] += valDiag;
                                assA[8][8] += valDiag;
                                break;
                            }
                        }
                      if ( (partP == P_RHS) || (partP == P_ALL) )
                        {
                           valSub = s*SIXTH*cauVals[1];
                           switch (curAss)
                            {
                              case N_STD:
                                assB[1] +=  valSub;
                                assB[2] +=  valSub;
                                assB[3] +=  valSub;
                                break;
                              case N_LQ:
                              case N_QQ:
                                assB[5] +=  valSub;
                                assB[7] +=  valSub;
                                assB[8] +=  valSub;
                                break;
                            }
                        }
                      break;
                    case 1 :
                      s = AreaT(p1,p3,p4);
                      if ( (partP==P_STIFF)||(partP==P_ALL) )
                        {
                          switch (curAss)
                            {
                              case N_STD:
                                valSub  = s*fac24*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[0][0] += valDiag;
                                assA[2][0] += valSub;
                                assA[2][2] += valDiag;
                                assA[3][0] += valSub;
                                assA[3][2] += valSub;
                                assA[3][3] += valDiag;
                                break;
                              case N_LQ:
                                valSub  = s*fac30*cauVals[0];
                                valDiag = TWO*valSub;
/*   printf(" N_LQ %e %e \n",valSub,valDiag);   */
                                assA[4][0] += valDiag;
                                assA[4][2] += valDiag;
                                assA[4][3] += valSub;
                                assA[7][0] += valSub;
                                assA[7][2] += valDiag;
                                assA[7][3] += valDiag;
                                assA[9][0] += valDiag;
                                assA[9][2] += valSub;
                                assA[9][3] += valDiag;
                                break;
                              case N_QQ:
                                valDiag = s*fac445*cauVals[0];
                                assA[4][4] += valDiag;
                                assA[7][7] += valDiag;
                                assA[9][9] += valDiag;
                                break;
                            }
                        }
                      if ( (partP == P_RHS) || (partP == P_ALL) )
                        {
                           valSub = s*SIXTH*cauVals[1];
                           switch (curAss)
                            {
                              case N_STD:
                                assB[0] +=  valSub;
                                assB[2] +=  valSub;
                                assB[3] +=  valSub;
                                break;
                              case N_LQ:
                              case N_QQ:
                                assB[4] +=  valSub;
                                assB[7] +=  valSub;
                                assB[9] +=  valSub;
                                break;
                            }
                        }
                      break;
                    case 2 :
                      s = AreaT(p1,p2,p4);
                      if ( (partP==P_STIFF)||(partP==P_ALL) )
                         {
                           switch (curAss)
                            {
                              case N_STD:
                                valSub  = s*fac24*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[0][0] += valDiag;
                                assA[1][0] += valSub;
                                assA[1][1] += valDiag;
                                assA[3][0] += valSub;
                                assA[3][1] += valSub;
                                assA[3][3] += valDiag;
                                break;
                              case N_LQ:
                                valSub  = s*fac30*cauVals[0];
                                valDiag = TWO*valSub;
/*   printf(" N_LQ %e %e \n",valSub,valDiag);   */
                                assA[6][0] += valDiag;
                                assA[6][1] += valDiag;
                                assA[6][3] += valSub;
                                assA[8][0] += valSub;
                                assA[8][1] += valDiag;
                                assA[8][3] += valDiag;
                                assA[9][0] += valDiag;
                                assA[9][1] += valSub;
                                assA[9][3] += valDiag;
                                break;
                              case N_QQ:
                                valDiag = s*fac445*cauVals[0];
                                assA[6][6] += valDiag;
                                assA[8][8] += valDiag;
                                assA[9][9] += valDiag;
                                break;
                            }
                         }
                      if ( (partP == P_RHS) || (partP == P_ALL) )
                        {
                           valSub = s*SIXTH*cauVals[1];
                           switch (curAss)
                            {
                              case N_STD:
                                assB[0] +=  valSub;
                                assB[1] +=  valSub;
                                assB[3] +=  valSub;
                                break;
                              case N_LQ:
                              case N_QQ:
                                assB[6] +=  valSub;
                                assB[8] +=  valSub;
                                assB[9] +=  valSub;
                                break;
                            }
                        }
                      break;
                    case 3 :
                      s = AreaT(p1,p2,p3);
                      if ( (partP==P_STIFF)||(partP==P_ALL) )
                         {
                           switch (curAss)
                            {
                              case N_STD:
                                valSub  = s*fac24*cauVals[0];
                                valDiag = TWO*valSub;
                                assA[0][0] += valDiag;
                                assA[1][0] += valSub;
                                assA[1][1] += valDiag;
                                assA[2][0] += valSub;
                                assA[2][1] += valSub;
                                assA[2][2] += valDiag;
                                break;
                              case N_LQ:
                                valSub  = s*fac30*cauVals[0];
                                valDiag = TWO*valSub;
/*  printf(" N_LQ %e %e \n",valSub,valDiag);   */
                                assA[4][0] += valDiag;
                                assA[4][1] += valSub;
                                assA[4][2] += valDiag;
                                assA[5][0] += valSub;
                                assA[5][1] += valDiag;
                                assA[5][2] += valDiag;
                                assA[6][0] += valDiag;
                                assA[6][1] += valDiag;
                                assA[6][2] += valSub;
                                break;
                              case N_QQ:
                                valDiag = s*fac445*cauVals[0];
                                assA[4][4] += valDiag;
                                assA[5][5] += valDiag;
                                assA[6][6] += valDiag;
                                break;
                            }
                         }
                      if ( (partP == P_RHS) || (partP == P_ALL) )
                        {
                           valSub = s*SIXTH*cauVals[1];
                           switch (curAss)
                            {
                              case N_STD:
                                assB[0] +=  valSub;
                                assB[1] +=  valSub;
                                assB[2] +=  valSub;
                                break;
                              case N_LQ:
                              case N_QQ:
                                assB[4] +=  valSub;
                                assB[5] +=  valSub;
                                assB[6] +=  valSub;
                                break;
                            }
                        }
                      break;
                  }
              }
         }


   return true;
}




INT Poisson(cmd)
  COMMAND *cmd;
  {

	if (ParsCheck(cmd,0,0)) return false;

	actProblem->NumAss = ConstAss;

	return true;
  }

INT Hyper(cmd)
  COMMAND *cmd;
  {
	if (ParsCheck(cmd,0,0)) return false;

	actProblem->NumAss = HyperAss;

	return true;
  }
