struct INTEGDATA
  {
    REAL *integPointX, *integPointY, *integPointZ, *integWeight;
	REAL **shape, **shapeX, **shapeY, **shapeZ,
		 **shapeXX, **shapeXY, **shapeYY;
	INT noOfIPoints, noOfShapeFunc, symP;
  };
typedef struct INTEGDATA INTEGDATA;

struct PROBLEM
  {
    char               *name;
    PROC                F;
    PROC                Obstacle;
    PROC                CauchyF;
    PROC                DirichF;
    PROC                Sol;
    PROC                NumAss;
    INT                 class;
    INT                 symP;
    struct PROBLEM     *next;
  };
typedef struct PROBLEM PROBLEM; 

#define NO_OF_F_VALS  5
#define NO_OF_CAU_VALS 2
#define NO_OF_DIR_VALS 1
#define NO_OF_SOL_VALS 4
#define NO_OF_OBST_VALS 2


#define CUBICIP 1
#define LINIP 2
#define QUADIP 3
#define USERIP 4
#define HYPERIP 5

#define N_STD 0
#define N_LL 1
#define N_LQ 2
#define N_QL 3
#define N_QQ 4
#define N_QUAD 5
#define N_EL 6
#define N_EQ 7

#define SYMMETRIC	1
#define DIAGONAL	2
#define FULL		0

#define P_STIFF 0
#define P_RHS 1
#define P_ALL 2

extern INT AssembleEnv();
extern INT AssembleSparse();
extern void SetBound();
extern INT axMul();
extern INT SparseAxMul();
extern INT InitNeighbors();
extern INT StoreNeighborsDegree();
extern INT StoreNeighbors();
extern void SetBoundZero();
extern INT MulD();
extern void pcxMul();
extern void bpxPcxMul();
extern INT AssRSide();
extern INT assign();
extern void assneg();
extern void lin();
extern void linneg();
extern void sub();
extern REAL scalprod();
extern void StoreVecToField();
extern void SetZeroField();
extern REAL CompRes();
extern REAL CompResExtrapol();
extern REAL SortResExtrapol();
extern INT InitNumAss();
extern INT NumAss();
extern INT eNormInt();
extern INT PrStiff();
extern void StdShape();
extern void StdQShape();
extern INT CompShapeVals();
extern INT UpdateIData();
extern INTEGDATA *NewIData();
extern REAL **ExpMatFull();
extern REAL *ExpVecFull();
extern void Set0MatFull();
extern void Set0MatSparse();
extern void Set0VecFull();
extern void PrintMatFull();
extern void PrintVecFull();
extern void Lev0DirectSol();


extern INT SelInteg();
extern INT TestInteg();
extern INT SetInteg();

extern REAL AreaT();

extern REAL **assA, *assB, **assAG, **assAL, *assBG;
extern INTEGDATA *stdIData, *qStdIData, *lStdIData;
extern userNoIP;
extern INT partP, noOfIPoints, noOfShapeFunc,
	   iFrom, iTo, kFrom, kTo, symP, curAss;
extern PROBLEM *actProblem;
extern REAL totalTime, dirTime, estiTime;
extern REAL refTime, assTime, iteTime, numTime;
extern REAL eNormU, eNormUUl;
