#ifndef NUL
#define NUL '\0'
#endif

#define MAX_COM 1000
#define MAX_PAR 100

typedef char **Names;
typedef char *CharClass;

struct COMMAND
  {
    INT no;
	INT noOfPars;
	char** pars;
	Names names;
  };
typedef struct COMMAND COMMAND;
typedef INT (*CMDPROC)();

struct TextElem
  {
    char *text;
	char *pos;
	PROC proc;
  };
typedef struct TextElem TextElem;
    
struct CMDMODES
  {
    INT		ignoreCases;
	INT		maxPars;
	char*	prompt;
	TextElem	*textStack;
	INT		maxCmdStack;
	INT		cmdStackP;
	INT		noOfNames;
	INT		maxIndex;
	Names	names;
	INT*	index;
	CMDPROC*	procs;
	char**	shortDes;
	Names*	pars;
	CharClass	delimClass;
	COMMAND*	cmd;
	char	escape;
	char	comment;
  };
typedef struct CMDMODES CMDMODES;

extern INT		InitCommands();
extern INT		DoCommands();
extern INT		ExecCommand();
extern COMMAND*	GetNextCommand();
extern void		SetCommand();

extern void		PrintCmdSettings();
extern void		PrintNames();
extern INT		CheckName();
extern INT		ParsCheck();
extern char		*ConvertString();

extern CMDMODES	stdCmdModes;

#define endClass 127
#define commandClass 10
#define parameterClass 5
#define nameClass 5
#define quoteClass 1
