
struct SOLVE
  {
    REAL	**stiff, *rhs, *diagonal, *solution;
    PTR         *decomp;
    INT         *env;
    INT         dirSolP, dirLevel, dirDim;
    INT         estiP, estiPosition, estiType, estiQuadraticP, constCoeff, keepP;
    REAL        estiThreshold;
    REAL        eNorm;
    INT	        dirFail, estiFail, refFail, iteFail;
    INT         lastStep, maxIteSteps, iteSteps;
    INT         precondP, sparseP, compNormP;
    REAL        globEps, iteEps, breakEps, iteFactor,
                sigma, sFactor, omega, minCorr;
    INT		breakDim, breakLevel, breakDepth, breakSteps;
    INT		layer, broydenDelta, renumber;
    VOIDPROC    Direct, Estimate, Refine, Iterate, Precond, Solver;
    PROC        RedRefine, MatrixMul, DirectSol;
    char        *preCondName, *estiName;
  };
typedef struct SOLVE SOLVE;

#define START 0
#define DIRECT 1
#define ESTIMATE 2
#define ITERATE 3
#define REFINE 4

#define INDEX 0
#define DEGREE 1

extern INT CholDecEnvelope();
extern INT CholSolEnvelope();
extern INT CholDecSparse();
extern INT CholSolSparse();
extern INT ChkSol();
extern INT ReverseCuthillMcKee();
extern INT NestedDissection();
extern INT NoSorting();
extern INT SparseLowerStruct();
extern INT CGFirst();
extern INT CGStep();
extern INT RenumberPts();
extern void InitBpx();


extern INT volumeKnown;
extern INT sparseExists;
extern SOLVE *actSolve;

extern REAL mbar, Theta, newFactor;
extern REAL discrErr, drawTime;

extern INT noOfFCalls;
