/*
C
C  _______________________________________________________________
C
C*   Licence
C    =======
C
C    You may use or modify this code for your own non commercial
C    purposes for an unlimited time. 
C    In any case you should not deliver this code without a special 
C    permission of ZIB.
C    In case you intend to use the code commercially, we oblige you
C    to sign an according licence agreement with ZIB.
C
C
C  _______________________________________________________________
C
*/

#include "kask.h"
#include "kasktri.h"



extern INT InitFixedLists();
extern INT InitList();
extern void ReturnList();
extern PTR *GetElem();
extern void ReturnElem();



static PTR**freeLists,**listBuckets;
static int*listLngs,*bucketLngs;
static INT maxL= -1;


static PTR*GetBucket();





INT InitFixedLists(maxLists)
  INT maxLists;
{
  INT k;
  freeLists= (PTR**)ZIBAlloc((long)maxLists*sizeof(PTR*));

  listBuckets= (PTR**)ZIBAlloc((long)maxLists*sizeof(PTR*));
  listLngs= (int*)ZIBAlloc((long)maxLists*sizeof(int));
  bucketLngs= (int*)ZIBAlloc((long)maxLists*sizeof(int));
  if(bucketLngs==nil)return false;

  maxL= maxLists;
  for (k= 0;k<maxL;k++)
   {
    freeLists[k]= nil;
    listBuckets[k]= nil;
    listLngs[k]= 0;
    bucketLngs[k]= 0;
   }


  return InitList(LISTLIST,2*sizeof(PTR),200);
}



INT InitList(no,lng,bucketSize)
  INT no,lng,bucketSize;
{
  if ((no<0)||(no>maxL))
    {
     sprintf(globBuf,"Lists: bad list index %d\n",no);
     ZIBStdOut(globBuf);
     return false;
    }

  if (listLngs[no]!=0)
    {
     sprintf(globBuf,"Lists: length redefinition not allowed (list %d)\n",no);
     ZIBStdOut(globBuf);
     return false;
    }



  listLngs[no]= lng;
  bucketLngs[no]= bucketSize;
  return true;
}



void ReturnList(no)
INT no;
{
PTR*buckets,*saveBucket;

if((no<0)||(no>maxL))
{sprintf(globBuf,"Lists: bad list index %d\n",no);ZIBStdOut(globBuf);return;}

buckets= listBuckets[no];
while(buckets!=nil)
{
ZIBFree((PTR)buckets[0]);
saveBucket= buckets;
buckets= (PTR*)buckets[0];
ReturnElem(LISTLIST,(PTR)saveBucket);
}
freeLists[no]= nil;
listLngs[no]= 0;
bucketLngs[no]= 0;


return;
}



PTR* GetElem(no)
INT no;
{
  PTR *elem, **lst;
  if ((no<0)||(no>maxL))
   {
    sprintf(globBuf,"Lists: bad list index %d\n",no);
    ZIBStdOut(globBuf);return false;
   }

  if (freeLists[no]==nil)
   {
    freeLists[no]= GetBucket(listLngs[no],bucketLngs[no]);
    if (freeLists[no]==nil) return false;
    if (no!=LISTLIST)
     {
      lst= (PTR**)GetElem(LISTLIST);
      if(lst==nil)return false;
      lst[0]= freeLists[no];
      lst[1]= listBuckets[no];
      listBuckets[no]= (PTR*)lst;
     }
    }


  elem= freeLists[no];
  freeLists[no]= (PTR*)freeLists[no][0];

return (PTR*)memset(elem,0,listLngs[no]);
}


void ReturnElem(no,elem)
INT no;
PTR* elem;
{
if((no<0)||(no>maxL))
{sprintf(globBuf,"Lists: bad list index %d\n",no);ZIBStdOut(globBuf);return;}

elem[0]= (PTR)freeLists[no];
freeLists[no]= elem;

return;
}



static PTR*GetBucket(lng,bucketSize)
INT lng,bucketSize;
{
PTR*bucket,*pt;
char *ptchar;
INT k;
bucket= (PTR*)ZIBAlloc((long)bucketSize*lng);
if(bucket==nil)return nil;

pt= bucket;
ptchar= (char*)pt+lng;
for(k= 0;k<bucketSize-1;k++)
{
pt[0]= (PTR)ptchar;
pt= (PTR*)ptchar;
ptchar+= lng;
}
pt[0]= nil;


return bucket;
}

