
#if(0)
  FTANGLE v1.13, tangled with SunOS/UNIX on "Tuesday, July 24, 1990 at 22:35." 
  COMMAND LINE: "ftangle params -#"
  RUN TIME: "Tuesday, September 4, 1990 at 14:23."
  WEB FILE NAME: "params.web"
  CHANGE FILE NAME: "/dev/null"
#endif



#define DOUBLE_INITIALIZED\
{ ZIBPrintf("Parameter module double initialized\n"); return false;}
#define NOT_ENOUGH_MEMORY(NO)\
{ ZIBPrintf("Not enough memory (%d)\n",NO); return false; }
#define ALREADY_DEFINED(LIST)\
{ ZIBPrintf("'%s' is already used as a parameter list name\n",LIST);\
return nil;}
#define TO_MANY_PARLISTS(LIST)\
{ ZIBPrintf("More than %d parameter list, could not enter '%s'\n",\
parListLng,LIST); return nil; }
#define NO_PARAM_SPACE(N,SIZE,LIST)\
{ ZIBPrintf("Can't allocate %d element of size %d for list '%s'\n",\
N,SIZE,LIST); return nil; }
#define NO_LIST(LIST)\
{ ZIBPrintf("Parameter list '%s' not defined\n",LIST); return false; }
#define NO_NAME(LIST,NAME)\
{ ZIBPrintf("'%s' not found in parameter list '%s'\n",NAME,LIST);\
return false; }




#include <stdio.h>
#include <string.h>

#define ZIBAlloc malloc
#define ZIBPrintf printf
#define ZIBFree free

#define SETZERO(P,N)\
for (stat_ind= 0;stat_ind<(N);stat_ind++)(P)[stat_ind]= '\0';
#define COPYVALUE(F,T,N)\
for (stat_ind= 0;stat_ind<(N);stat_ind++)(T)[stat_ind]= (F)[stat_ind];

#define true 1
#define false 0
#define nil 0l

#define MAXPARAMS 100

typedef int INT;
typedef char*ptr;
typedef INT(*proc)();



struct paramList
{
char*listName,**parNames;
INT noOfParams,valueSize,valueType;
ptr values;
proc UserParamChanged,UserListChanged;
};
typedef struct paramList paramList;



extern INT InitParamLists();
extern ptr NewParamList();
extern INT ReturnParamList();
extern INT GetParamList();
extern INT GetParam();
extern char**GetListNames();
extern INT ChangeParam();
extern INT ChangedParamList();



static paramList**pLists= nil;
static char**pNames= nil;
static INT parListLng= 0;
static INT stat_ind;




static INT CheckListName(listName)
char*listName;
{
INT k;

if(pLists==nil)
{InitParamLists(MAXPARAMS);return-1;}
for(k= 0;k<parListLng;k++)
{
if(pLists[k]==nil)continue;
if(strcmp(listName,pLists[k]->listName)==0)break;
}
return(k==parListLng)?-1:k;
}



static INT CheckList(name,names,n)
char*name,**names;
INT n;
{
INT k,pos;

if(names)
{
for(k= 0;k<n;k++)
{
if(names[k]==nil)continue;
if(strcmp(name,names[k])==0)break;
}
if(k<n)return k;
}
if(sscanf(name,"%d",&pos)!=1)return-1;
return((pos<0)||(pos>=n))?-1:pos;
}



static char*CopyString(s)
char*s;
{
INT lng= strlen(s);
char*c= (char*)ZIBAlloc((long)lng);

if(c==nil)NOT_ENOUGH_MEMORY(4);
return strcpy(c,s);
}

static void ReleaseString(s)
char*s;
{
ZIBFree(s);
return;
}






INT InitParamLists(maxParams)
INT maxParams;
{
INT k;

if(pLists)DOUBLE_INITIALIZED;

pLists= 
(paramList**)ZIBAlloc((long)(maxParams*sizeof(paramList*)));
if(pLists==nil)NOT_ENOUGH_MEMORY(1)

pNames= (char**)ZIBAlloc((long)(maxParams*sizeof(char*)));
if(pNames==nil)NOT_ENOUGH_MEMORY(2)

for(k= 0;k<maxParams;k++)
{pLists[k]= nil;pNames[k]= nil;}
parListLng= maxParams;
return true;
}




ptr NewParamList(listName,noOfParams,valueSize,valueType,names,
UserParamChanged,UserListChanged)
char*listName,**names;
INT noOfParams,valueSize,valueType;
proc UserParamChanged,UserListChanged;
{
INT k;
paramList*pL;

k= CheckListName(listName);
if(k>=0)ALREADY_DEFINED(listName)

for(k= 0;k<parListLng;k++)
if(pLists[k]==nil)break;
if(parListLng==k)TO_MANY_PARLISTS(listName)

pL= (paramList*)ZIBAlloc((long)(sizeof(paramList)));
if(pL==nil)NOT_ENOUGH_MEMORY(3)

pL->listName= CopyString(listName);
if(pL->listName==nil)return nil;
pL->values= (ptr)ZIBAlloc((long)(noOfParams*valueSize));
if(pL->values==nil)
NO_PARAM_SPACE(noOfParams,valueSize,listName)
SETZERO(pL->values,noOfParams*valueSize);

pL->parNames= names;
pL->noOfParams= noOfParams;
pL->valueSize= valueSize;
pL->UserParamChanged= UserParamChanged;
pL->UserListChanged= UserListChanged;
pL->valueType= valueType;

pLists[k]= pL;
pNames[k]= pL->listName;
return pL->values;
}




INT ReturnParamList(listName)
char*listName;
{
INT k;
paramList*pL;

k= CheckListName(listName);
if(k<0)NO_LIST(listName)
pL= pLists[k];

ZIBFree(pL->values);
ReleaseString(pL->listName);
SETZERO((char*)pL,sizeof(paramList));

ZIBFree(pL);
pLists[k]= nil;
pNames[k]= nil;

return true;
}




INT GetParamList(listName,names,values,noOfParams,valueType)
char*listName,***names;
ptr*values;
int*noOfParams,*valueType;
{
INT k;
paramList*pL;

k= CheckListName(listName);
if(k<0)NO_LIST(listName)
pL= pLists[k];

*names= pL->parNames;
*values= pL->values;
*noOfParams= pL->noOfParams;
*valueType= pL->valueType;

return true;
}




INT GetParam(listName,name,value)
char*listName,*name;
ptr value;
{
INT i,k;
paramList*pL;

k= CheckListName(listName);
if(k<0)NO_LIST(listName)
pL= pLists[k];

i= CheckList(name,pL->parNames,pL->noOfParams);
if(i<0)NO_NAME(listName,name)

COPYVALUE(&(pL->values)[i*(pL->valueSize)],value,pL->valueSize);

return true;
}




char**GetListNames(lng)
int*lng;
{
if(pLists==nil)InitParamLists(MAXPARAMS);
*lng= parListLng;
return pNames;
}




INT ChangeParam(nameList,name,value)
char*nameList,*name;
ptr value;
{
INT i,k;
paramList*pL;

k= CheckListName(nameList);
if(k<0)NO_LIST(nameList)
pL= pLists[k];

i= CheckList(name,pL->parNames,pL->noOfParams);
if(i<0)NO_NAME(nameList,name)

COPYVALUE(value,&(pL->values)[i*(pL->valueSize)],pL->valueSize);

if(pL->UserParamChanged)
return(pL->UserParamChanged)(nameList,name,i);
else return true;
}




INT ChangedParamList(nameList)
char*nameList;
{
INT k;
paramList*pL;

k= CheckListName(nameList);
if(k<0)NO_LIST(nameList)
pL= pLists[k];

if(pL->UserListChanged)
return(pL->UserListChanged)(nameList);
else return true;
}






